--- old/usr/src/cmd/sendmail/src/milter.c	Sat Feb  6 15:36:46 2016
+++ new/usr/src/cmd/sendmail/src/milter.c	Sat Feb  6 15:36:46 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1999-2009 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1999-2009, 2012, 2013 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -10,7 +10,7 @@
 
 #include <sendmail.h>
 
-SM_RCSID("@(#)$Id: milter.c,v 8.277 2009/11/06 00:57:06 ca Exp $")
+SM_RCSID("@(#)$Id: milter.c,v 8.281 2013-11-22 20:51:56 ca Exp $")
 
 #if MILTER
 # include <sm/sendmail.h>
@@ -42,7 +42,7 @@
 			time_t, ENVELOPE *, const char *));
 static char	*milter_send_command __P((struct milter *, int, void *,
 			ssize_t, ENVELOPE *, char *, const char *));
-static char	*milter_command __P((int, void *, ssize_t, char **,
+static char	*milter_command __P((int, void *, ssize_t, int,
 			ENVELOPE *, char *, const char *, bool));
 static char	*milter_body __P((struct milter *, ENVELOPE *, char *));
 static int	milter_reopen_df __P((ENVELOPE *));
@@ -79,13 +79,13 @@
 # define SMFS_READY		'R'	/* ready for action */
 # define SMFS_SKIP		'S'	/* skip body */
 
-static char *MilterConnectMacros[MAXFILTERMACROS + 1];
-static char *MilterHeloMacros[MAXFILTERMACROS + 1];
-static char *MilterEnvFromMacros[MAXFILTERMACROS + 1];
-static char *MilterEnvRcptMacros[MAXFILTERMACROS + 1];
-static char *MilterDataMacros[MAXFILTERMACROS + 1];
-static char *MilterEOMMacros[MAXFILTERMACROS + 1];
-static char *MilterEOHMacros[MAXFILTERMACROS + 1];
+/*
+**  MilterMacros contains the milter macros for each milter and each stage.
+**  indices are (in order): stages, milter-index, macro
+**  milter-index == 0: "global" macros (not for a specific milter).
+*/
+
+static char *MilterMacros[SMFIM_LAST + 1][MAXFILTERS + 1][MAXFILTERMACROS + 1];
 static size_t MilterMaxDataSize = MILTER_MAX_DATA_SIZE;
 
 # define MILTER_CHECK_DONE_MSG() \
@@ -98,6 +98,16 @@
 		milter_abort(e); \
 	}
 
+/* set state in case of an error */
+# define MILTER_SET_STATE	\
+	if (bitnset(SMF_TEMPFAIL, m->mf_flags)) \
+		*state = SMFIR_TEMPFAIL; \
+	else if (bitnset(SMF_TEMPDROP, m->mf_flags)) \
+		*state = SMFIR_SHUTDOWN; \
+	else if (bitnset(SMF_REJECT, m->mf_flags)) \
+		*state = SMFIR_REJECT
+
+/* flow through code maybe using continue; don't wrap in do {} while */
 # define MILTER_CHECK_ERROR(initial, action) \
 	if (!initial && tTd(71, 100)) \
 	{ \
@@ -119,12 +129,7 @@
 				  e->e_quarmsg); \
 		} \
 	} \
-	else if (bitnset(SMF_TEMPFAIL, m->mf_flags)) \
-		*state = SMFIR_TEMPFAIL; \
-	else if (bitnset(SMF_TEMPDROP, m->mf_flags)) \
-		*state = SMFIR_SHUTDOWN; \
-	else if (bitnset(SMF_REJECT, m->mf_flags)) \
-		*state = SMFIR_REJECT; \
+	else MILTER_SET_STATE;	\
 	else \
 		action;
 
@@ -1221,6 +1226,7 @@
 	char *p;
 	struct milter *m;
 	STAB *s;
+	static int idx = 0;
 
 	/* collect the filter name */
 	for (p = line;
@@ -1323,7 +1329,10 @@
 	if (s->s_milter != NULL)
 		syserr("X%s: duplicate filter definition", m->mf_name);
 	else
+	{
 		s->s_milter = m;
+		m->mf_idx = ++idx;
+	}
 }
 
 /*
@@ -1555,20 +1564,13 @@
 	unsigned char	mo_code;	/* code for option */
 } MilterOptTab[] =
 {
-# define MO_MACROS_CONNECT		SMFIM_CONNECT
-	{ "macros.connect",		MO_MACROS_CONNECT		},
-# define MO_MACROS_HELO			SMFIM_HELO
-	{ "macros.helo",		MO_MACROS_HELO			},
-# define MO_MACROS_ENVFROM		SMFIM_ENVFROM
-	{ "macros.envfrom",		MO_MACROS_ENVFROM		},
-# define MO_MACROS_ENVRCPT		SMFIM_ENVRCPT
-	{ "macros.envrcpt",		MO_MACROS_ENVRCPT		},
-# define MO_MACROS_DATA			SMFIM_DATA
-	{ "macros.data",		MO_MACROS_DATA			},
-# define MO_MACROS_EOM			SMFIM_EOM
-	{ "macros.eom",			MO_MACROS_EOM			},
-# define MO_MACROS_EOH			SMFIM_EOH
-	{ "macros.eoh",			MO_MACROS_EOH			},
+	{ "macros.connect",		SMFIM_CONNECT			},
+	{ "macros.helo",		SMFIM_HELO			},
+	{ "macros.envfrom",		SMFIM_ENVFROM			},
+	{ "macros.envrcpt",		SMFIM_ENVRCPT			},
+	{ "macros.data",		SMFIM_DATA			},
+	{ "macros.eom",			SMFIM_EOM			},
+	{ "macros.eoh",			SMFIM_EOH			},
 
 # define MO_LOGLEVEL			0x07
 	{ "loglevel",			MO_LOGLEVEL			},
@@ -1655,40 +1657,15 @@
 		break;
 # endif /* _FFR_MAXDATASIZE || _FFR_MDS_NEGOTIATE */
 
-	  case MO_MACROS_CONNECT:
-		if (macros == NULL)
-			macros = MilterConnectMacros;
-		/* FALLTHROUGH */
+	  case SMFIM_CONNECT:
+	  case SMFIM_HELO:
+	  case SMFIM_ENVFROM:
+	  case SMFIM_ENVRCPT:
+	  case SMFIM_EOH:
+	  case SMFIM_EOM:
+	  case SMFIM_DATA:
+		macros = MilterMacros[mo->mo_code][0];
 
-	  case MO_MACROS_HELO:
-		if (macros == NULL)
-			macros = MilterHeloMacros;
-		/* FALLTHROUGH */
-
-	  case MO_MACROS_ENVFROM:
-		if (macros == NULL)
-			macros = MilterEnvFromMacros;
-		/* FALLTHROUGH */
-
-	  case MO_MACROS_ENVRCPT:
-		if (macros == NULL)
-			macros = MilterEnvRcptMacros;
-		/* FALLTHROUGH */
-
-	  case MO_MACROS_EOH:
-		if (macros == NULL)
-			macros = MilterEOHMacros;
-		/* FALLTHROUGH */
-
-	  case MO_MACROS_EOM:
-		if (macros == NULL)
-			macros = MilterEOMMacros;
-		/* FALLTHROUGH */
-
-	  case MO_MACROS_DATA:
-		if (macros == NULL)
-			macros = MilterDataMacros;
-
 		r = milter_set_macros(name, macros, val, nummac);
 		if (r >= 0)
 			nummac = r;
@@ -2188,7 +2165,7 @@
 			sm_syslog(LOG_ERR, e->e_id,
 				  "milter_send_command(%s): action=%s returned bogus response %c",
 				  m->mf_name, action, rcmd);
-		milter_error(m, e);
+		milter_error(m, e); /* NO ERROR CHECK? */
 		break;
 	}
 
@@ -2207,7 +2184,7 @@
 **		cmd -- command to send.
 **		data -- optional command data.
 **		sz -- length of buf.
-**		macros -- macros to send for filter smfi_getsymval().
+**		stage -- index of macros to send for filter smfi_getsymval().
 **		e -- current envelope (for macro access).
 **		state -- return state word.
 **		where -- description of calling function (logging).
@@ -2218,11 +2195,11 @@
 */
 
 static char *
-milter_command(cmd, data, sz, macros, e, state, where, cmd_error)
+milter_command(cmd, data, sz, stage, e, state, where, cmd_error)
 	int cmd;
 	void *data;
 	ssize_t sz;
-	char **macros;
+	int stage;
 	ENVELOPE *e;
 	char *state;
 	const char *where;
@@ -2254,14 +2231,27 @@
 		    (m->mf_state != SMFS_OPEN && m->mf_state != SMFS_INMSG))
 			continue;
 
-		/* send macros (regardless of whether we send command) */
-		if (macros != NULL && macros[0] != NULL)
+		if (stage >= SMFIM_FIRST && stage <= SMFIM_LAST)
 		{
-			milter_send_macros(m, macros, command, e);
-			if (m->mf_state == SMFS_ERROR)
+			int idx;
+			char **macros;
+
+			if ((m->mf_lflags & MI_LFLAGS_SYM(stage)) != 0)
+				idx = m->mf_idx;
+			else
+				idx = 0;
+			SM_ASSERT(idx >= 0 && idx <= MAXFILTERS);
+			macros = MilterMacros[stage][idx];
+
+			/* send macros (regardless of whether we send cmd) */
+			if (macros != NULL && macros[0] != NULL)
 			{
-				MILTER_CHECK_ERROR(false, continue);
-				break;
+				milter_send_macros(m, macros, command, e);
+				if (m->mf_state == SMFS_ERROR)
+				{
+					MILTER_CHECK_ERROR(false, continue);
+					break;
+				}
 			}
 		}
 
@@ -2329,40 +2319,16 @@
 
 		switch (i)
 		{
-		  case MO_MACROS_CONNECT:
-			if (macros == NULL)
-				macros = MilterConnectMacros;
-			/* FALLTHROUGH */
-
-		  case MO_MACROS_HELO:
-			if (macros == NULL)
-				macros = MilterHeloMacros;
-			/* FALLTHROUGH */
-
-		  case MO_MACROS_ENVFROM:
-			if (macros == NULL)
-				macros = MilterEnvFromMacros;
-			/* FALLTHROUGH */
-
-		  case MO_MACROS_ENVRCPT:
-			if (macros == NULL)
-				macros = MilterEnvRcptMacros;
-			/* FALLTHROUGH */
-
-		  case MO_MACROS_EOM:
-			if (macros == NULL)
-				macros = MilterEOMMacros;
-			/* FALLTHROUGH */
-
-		  case MO_MACROS_EOH:
-			if (macros == NULL)
-				macros = MilterEOHMacros;
-			/* FALLTHROUGH */
-
-		  case MO_MACROS_DATA:
-			if (macros == NULL)
-				macros = MilterDataMacros;
-
+		  case SMFIM_CONNECT:
+		  case SMFIM_HELO:
+		  case SMFIM_ENVFROM:
+		  case SMFIM_ENVRCPT:
+		  case SMFIM_EOH:
+		  case SMFIM_EOM:
+		  case SMFIM_DATA:
+			SM_ASSERT(m->mf_idx > 0 && m->mf_idx < MAXFILTERS);
+			macros = MilterMacros[i][m->mf_idx];
+			m->mf_lflags |= MI_LFLAGS_SYM(i);
 			len = strlen(buf + offset);
 			if (len > 0)
 			{
@@ -2370,6 +2336,9 @@
 						buf + offset, nummac);
 				if (r >= 0)
 					nummac = r;
+				if (tTd(64, 5))
+					sm_dprintf("milter_getsymlist(%s, %s)=%d\n",
+						m->mf_name, buf + offset, r);
 			}
 			break;
 
@@ -3989,7 +3958,7 @@
 		(void) memcpy(bp, sockinfo, strlen(sockinfo) + 1);
 	}
 
-	response = milter_command(SMFIC_CONNECT, buf, s, MilterConnectMacros,
+	response = milter_command(SMFIC_CONNECT, buf, s, SMFIM_CONNECT,
 				e, state, "connect", false);
 	sm_free(buf); /* XXX */
 
@@ -4078,7 +4047,7 @@
 	}
 
 	response = milter_command(SMFIC_HELO, helo, strlen(helo) + 1,
-				  MilterHeloMacros, e, state, "helo", false);
+				  SMFIM_HELO, e, state, "helo", false);
 	milter_per_connection_check(e);
 	return response;
 }
@@ -4166,7 +4135,7 @@
 		sm_syslog(LOG_INFO, e->e_id, "Milter: sender: %s", buf);
 
 	/* send it over */
-	response = milter_command(SMFIC_MAIL, buf, s, MilterEnvFromMacros,
+	response = milter_command(SMFIC_MAIL, buf, s, SMFIM_ENVFROM,
 				e, state, "mail", false);
 	sm_free(buf); /* XXX */
 
@@ -4247,7 +4216,7 @@
 		sm_syslog(LOG_INFO, e->e_id, "Milter: rcpts: %s", buf);
 
 	/* send it over */
-	response = milter_command(SMFIC_RCPT, buf, s, MilterEnvRcptMacros,
+	response = milter_command(SMFIC_RCPT, buf, s, SMFIM_ENVRCPT,
 				e, state, "rcpt", rcpt_error);
 	sm_free(buf); /* XXX */
 	return response;
@@ -4273,8 +4242,8 @@
 		sm_dprintf("milter_data_cmd\n");
 
 	/* send it over */
-	return milter_command(SMFIC_DATA, NULL, 0, MilterDataMacros, e, state,
-				"data", false);
+	return milter_command(SMFIC_DATA, NULL, 0, SMFIM_DATA,
+				e, state, "data", false);
 }
 
 /*
@@ -4293,7 +4262,12 @@
 **		  modify the envelope or message.
 */
 
+/* flow through code using continue; don't wrap in do {} while */
 # define MILTER_CHECK_RESULTS() \
+	if (m->mf_state == SMFS_ERROR && *state == SMFIR_CONTINUE) \
+	{ \
+			MILTER_SET_STATE;	\
+	} \
 	if (*state == SMFIR_ACCEPT || \
 	    m->mf_state == SMFS_DONE || \
 	    m->mf_state == SMFS_ERROR) \
@@ -4339,6 +4313,8 @@
 
 	for (i = 0; InputFilters[i] != NULL; i++)
 	{
+		int idx;
+		char **macros;
 		struct milter *m = InputFilters[i];
 
 		if (*state != SMFIR_CONTINUE &&
@@ -4383,10 +4359,16 @@
 			if (tTd(64, 10))
 				sm_dprintf("milter_data: eoh\n");
 
-			if (MilterEOHMacros[0] != NULL)
+			if ((m->mf_lflags & MI_LFLAGS_SYM(SMFIM_EOH)) != 0)
+				idx = m->mf_idx;
+			else
+				idx = 0;
+			SM_ASSERT(idx >= 0 && idx <= MAXFILTERS);
+			macros = MilterMacros[SMFIM_EOH][idx];
+
+			if (macros != NULL)
 			{
-				milter_send_macros(m, MilterEOHMacros,
-					   SMFIC_EOH, e);
+				milter_send_macros(m, macros, SMFIC_EOH, e);
 				MILTER_CHECK_RESULTS();
 			}
 
@@ -4405,10 +4387,15 @@
 			MILTER_CHECK_RESULTS();
 		}
 
-		if (MilterEOMMacros[0] != NULL)
+		if ((m->mf_lflags & MI_LFLAGS_SYM(SMFIM_EOH)) != 0)
+			idx = m->mf_idx;
+		else
+			idx = 0;
+		SM_ASSERT(idx >= 0 && idx <= MAXFILTERS);
+		macros = MilterMacros[SMFIM_EOM][idx];
+		if (macros != NULL)
 		{
-			milter_send_macros(m, MilterEOMMacros,
-					   SMFIC_BODYEOB, e);
+			milter_send_macros(m, macros, SMFIC_BODYEOB, e);
 			MILTER_CHECK_RESULTS();
 		}
 
@@ -4734,7 +4721,7 @@
 		sm_dprintf("milter_unknown(%s)\n", smtpcmd);
 
 	return milter_command(SMFIC_UNKNOWN, smtpcmd, strlen(smtpcmd) + 1,
-				NULL, e, state, "unknown", false);
+				SMFIM_NOMACROS, e, state, "unknown", false);
 }
 
 /*
--- old/usr/src/cmd/sendmail/src/mime.c	Sat Feb  6 15:36:46 2016
+++ new/usr/src/cmd/sendmail/src/mime.c	Sat Feb  6 15:36:46 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1998-2003, 2006 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1998-2003, 2006, 2013 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  * Copyright (c) 1994, 1996-1997 Eric P. Allman.  All rights reserved.
  * Copyright (c) 1994
@@ -11,12 +11,10 @@
  *
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sendmail.h>
 #include <string.h>
 
-SM_RCSID("@(#)$Id: mime.c,v 8.147 2007/09/26 23:29:11 ca Exp $")
+SM_RCSID("@(#)$Id: mime.c,v 8.149 2013-11-22 20:51:56 ca Exp $")
 
 /*
 **  MIME support.
@@ -109,6 +107,7 @@
 {
 	register char *p;
 	int linelen;
+	int blen;
 	int bt;
 	off_t offset;
 	size_t sectionsize, sectionhighbits;
@@ -324,13 +323,13 @@
 			goto writeerr;
 		mci->mci_flags &= ~MCIF_INHEADER;
 		bt = MBT_FINAL;
-		while (sm_io_fgets(e->e_dfp, SM_TIME_DEFAULT, buf, sizeof(buf))
-			!= NULL)
+		while ((blen = sm_io_fgets(e->e_dfp, SM_TIME_DEFAULT, buf,
+					sizeof(buf))) >= 0)
 		{
 			bt = mimeboundary(buf, boundaries);
 			if (bt != MBT_NOTSEP)
 				break;
-			if (!putxline(buf, strlen(buf), mci,
+			if (!putxline(buf, blen, mci,
 					PXLF_MAPFROM|PXLF_STRIP8BIT))
 				goto writeerr;
 			if (tTd(43, 99))
@@ -368,13 +367,13 @@
 		mci->mci_flags &= ~MCIF_INMIME;
 
 		/* skip the late "comment" epilogue */
-		while (sm_io_fgets(e->e_dfp, SM_TIME_DEFAULT, buf, sizeof(buf))
-			!= NULL)
+		while ((blen = sm_io_fgets(e->e_dfp, SM_TIME_DEFAULT, buf,
+					sizeof(buf))) >= 0)
 		{
 			bt = mimeboundary(buf, boundaries);
 			if (bt != MBT_NOTSEP)
 				break;
-			if (!putxline(buf, strlen(buf), mci,
+			if (!putxline(buf, blen, mci,
 					PXLF_MAPFROM|PXLF_STRIP8BIT))
 				goto writeerr;
 			if (tTd(43, 99))
@@ -445,16 +444,16 @@
 			       DATAFL_LETTER, e->e_id);
 
 		/* do a scan of this body type to count character types */
-		while (sm_io_fgets(e->e_dfp, SM_TIME_DEFAULT, buf, sizeof(buf))
-			!= NULL)
+		while ((blen = sm_io_fgets(e->e_dfp, SM_TIME_DEFAULT, buf,
+					sizeof(buf))) >= 0)
 		{
 			if (mimeboundary(buf, boundaries) != MBT_NOTSEP)
 				break;
-			for (p = buf; *p != '\0'; p++)
+			for (i = 0; i < blen; i++)
 			{
 				/* count bytes with the high bit set */
 				sectionsize++;
-				if (bitset(0200, *p))
+				if (bitset(0200, buf[i]))
 					sectionhighbits++;
 			}
 
@@ -524,8 +523,8 @@
 		if (!putline("", mci))
 			goto writeerr;
 		mci->mci_flags &= ~MCIF_INHEADER;
-		while (sm_io_fgets(e->e_dfp, SM_TIME_DEFAULT, buf, sizeof(buf))
-			!= NULL)
+		while ((blen = sm_io_fgets(e->e_dfp, SM_TIME_DEFAULT, buf,
+					sizeof(buf))) >= 0)
 		{
 			if (!bitset(MCIF_INLONGLINE, mci->mci_flags))
 			{
@@ -533,7 +532,7 @@
 				if (bt != MBT_NOTSEP)
 					break;
 			}
-			if (!putxline(buf, strlen(buf), mci,
+			if (!putxline(buf, blen, mci,
 				      PXLF_MAPFROM|PXLF_NOADDEOL))
 				goto writeerr;
 		}
@@ -1035,7 +1034,7 @@
 	HDR *header;
 	register ENVELOPE *e;
 {
-	int pxflags;
+	int pxflags, blen;
 	register char *p;
 	char *cte;
 	char **pvp;
@@ -1068,10 +1067,10 @@
 		if (!putline("", mci))
 			goto writeerr;
 		mci->mci_flags &= ~MCIF_INHEADER;
-		while (sm_io_fgets(e->e_dfp, SM_TIME_DEFAULT, buf, sizeof(buf))
-			!= NULL)
+		while ((blen = sm_io_fgets(e->e_dfp, SM_TIME_DEFAULT, buf,
+					sizeof(buf))) >= 0)
 		{
-			if (!putline(buf, mci))
+			if (!putxline(buf, blen, mci, PXLF_MAPFROM))
 				goto writeerr;
 		}
 		return true;
@@ -1179,7 +1178,7 @@
 		pxflags |= PXLF_NOADDEOL;
 		fbufp = fbuf;
 		while (sm_io_fgets(e->e_dfp, SM_TIME_DEFAULT, buf,
-				   sizeof(buf)) != NULL)
+				   sizeof(buf)) >= 0)
 		{
 			off = mime_fromqp((unsigned char *) buf, &fbufp,
 					  &fbuf[MAXLINE] - fbufp);
--- old/usr/src/cmd/sendmail/src/parseaddr.c	Sat Feb  6 15:36:46 2016
+++ new/usr/src/cmd/sendmail/src/parseaddr.c	Sat Feb  6 15:36:46 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1998-2006 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1998-2006 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  * Copyright (c) 1983, 1995-1997 Eric P. Allman.  All rights reserved.
  * Copyright (c) 1988, 1993
@@ -11,11 +11,9 @@
  *
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sendmail.h>
 
-SM_RCSID("@(#)$Id: parseaddr.c,v 8.403 2008/02/08 02:27:35 ca Exp $")
+SM_RCSID("@(#)$Id: parseaddr.c,v 8.407 2013-11-22 20:51:56 ca Exp $")
 
 #include <sm/sendmail.h>
 #include "map.h"
@@ -244,6 +242,7 @@
 **
 **	Parameters:
 **		addr -- the address to check.
+**		  note: this is the complete address (including display part)
 **		delimptr -- if non-NULL: end of address to check, i.e.,
 **			a pointer in the address string.
 **		isrcpt -- true iff the address is for a recipient.
@@ -321,7 +320,7 @@
 **			is invalid and should be "repaired".
 **
 **	Returns:
-**		true -- if the address has any "wierd" characters or
+**		true -- if the address has any "weird" characters or
 **			non-printable characters or if a quote is unbalanced.
 **		false -- otherwise.
 */
@@ -2351,6 +2350,14 @@
 	if (a->q_mailer != b->q_mailer)
 		return false;
 
+	/*
+	**  Addresses resolving to error mailer
+	**  should not be considered identical
+	*/
+
+	if (a->q_mailer == &errormailer)
+		return false;
+
 	/* if the user isn't the same, we can drop out */
 	if (strcmp(a->q_user, b->q_user) != 0)
 		return false;
--- old/usr/src/cmd/sendmail/src/queue.c	Sat Feb  6 15:36:46 2016
+++ new/usr/src/cmd/sendmail/src/queue.c	Sat Feb  6 15:36:46 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1998-2009 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1998-2009, 2011, 2012 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  * Copyright (c) 1983, 1995-1997 Eric P. Allman.  All rights reserved.
  * Copyright (c) 1988, 1993
@@ -14,7 +14,7 @@
 #include <sendmail.h>
 #include <sm/sem.h>
 
-SM_RCSID("@(#)$Id: queue.c,v 8.987 2009/12/18 17:08:01 ca Exp $")
+SM_RCSID("@(#)$Id: queue.c,v 8.1000 2013-11-22 20:51:56 ca Exp $")
 
 #include <dirent.h>
 
@@ -203,7 +203,7 @@
 **	tag -- should be a unique id to avoid misinterpretations by others.
 **		idea: hash over configuration data that will be stored here.
 **	NumFileSys -- number of file systems.
-**	FileSys -- (arrary of) structure for used file systems.
+**	FileSys -- (array of) structure for used file systems.
 **	RSATmpCnt -- counter for number of uses of ephemeral RSA key.
 **	QShm -- (array of) structure for information about queue directories.
 */
@@ -633,7 +633,6 @@
 	}
 
 	/* output inode number of data file */
-	/* XXX should probably include device major/minor too */
 	if (e->e_dfino != -1)
 	{
 		(void) sm_io_fprintf(tfp, SM_TIME_DEFAULT, "I%ld/%ld/%llu\n",
@@ -1494,6 +1493,7 @@
 	for (i = 0; i < NumWorkGroups && !NoMoreRunners; i++)
 	{
 		int rwgflags = RWG_NONE;
+		int wasblocked;
 
 		/*
 		**  If MaxQueueChildren active then test whether the start
@@ -1530,7 +1530,11 @@
 		**  increase if some queue runners "hang" for a long time.
 		*/
 
+		/* don't let proc_list_drop() change CurRunners */
+		wasblocked = sm_blocksignal(SIGCHLD);
 		CurRunners += WorkGrp[curnum].wg_maxact;
+		if (wasblocked == 0)
+			(void) sm_releasesignal(SIGCHLD);
 		if (forkflag)
 			rwgflags |= RWG_FORK;
 		if (verbose)
@@ -1550,7 +1554,13 @@
 
 		if (!ret)
 		{
+			/* don't let proc_list_drop() change CurRunners */
+			wasblocked = sm_blocksignal(SIGCHLD);
 			CurRunners -= WorkGrp[curnum].wg_maxact;
+			CHK_CUR_RUNNERS("runqueue", curnum,
+					WorkGrp[curnum].wg_maxact);
+			if (wasblocked == 0)
+				(void) sm_releasesignal(SIGCHLD);
 			break;
 		}
 
@@ -2032,6 +2042,9 @@
 	{
 		IgnoreHostStatus = true;
 		MinQueueAge = 0;
+#if _FFR_EXPDELAY
+		MaxQueueAge = 0;
+#endif /* _FFR_EXPDELAY */
 	}
 
 	/*
@@ -2301,7 +2314,7 @@
 	if (bitset(RWG_PERSISTENT, flags))
 	{
 		sequenceno = 1;
-		sm_setproctitle(true, CurEnv, "running queue: %s",
+		sm_setproctitle(true, NULL, "running queue: %s",
 				qid_printqueue(qgrp, qdir));
 
 		/*
@@ -2733,7 +2746,7 @@
 			i |= NEED_QUARANTINE;
 		while (cf != NULL && i != 0 &&
 		       sm_io_fgets(cf, SM_TIME_DEFAULT, lbuf,
-				   sizeof(lbuf)) != NULL)
+				   sizeof(lbuf)) >= 0)
 		{
 			int c;
 			time_t age;
@@ -2861,7 +2874,7 @@
 #if _FFR_EXPDELAY
 				if (MaxQueueAge > 0)
 				{
-					time_t lasttry, delay;    
+					time_t lasttry, delay;
 
 					lasttry = (time_t) atol(&lbuf[1]);
 					delay = MIN(lasttry - w->w_ctime,
@@ -2927,7 +2940,7 @@
 **
 **	First the old WorkQ is cleared away. Then the WorkList is sorted
 **	for all items so that important (higher sorting value) items are not
-**	trunctated off. Then the most important items are moved from
+**	truncated off. Then the most important items are moved from
 **	WorkList to WorkQ. The lower count of 'max' or MaxListCount items
 **	are moved.
 **
@@ -3705,6 +3718,7 @@
 			(void) dropenvelope(e, true, false);
 			sm_rpool_free(rpool);
 			e->e_rpool = NULL;
+			e->e_message = NULL;
 		}
 	}
 	e->e_id = NULL;
@@ -4578,7 +4592,7 @@
 			e->e_dfdev = st.st_dev;
 			e->e_dfino = ST_INODE(st);
 			(void) sm_snprintf(buf, sizeof(buf), "%ld",
-					   e->e_msgsize);
+					   PRT_NONNEGL(e->e_msgsize));
 			macdefine(&e->e_macro, A_TEMP, macid("{msg_size}"),
 				  buf);
 		}
@@ -4967,7 +4981,7 @@
 		quarmsg[0] = '\0';
 		statmsg[0] = bodytype[0] = '\0';
 		qfver = 0;
-		while (sm_io_fgets(f, SM_TIME_DEFAULT, buf, sizeof(buf)) != NULL)
+		while (sm_io_fgets(f, SM_TIME_DEFAULT, buf, sizeof(buf)) >= 0)
 		{
 			register int i;
 			register char *p;
@@ -5195,7 +5209,11 @@
 
 	/* Assign an ID if needed */
 	if (e->e_id == NULL)
+	{
+		if (IntSig)
+			return NULL;
 		assign_queueid(e);
+	}
 	type = queue_letter(e, type);
 
 	/* begin of filename */
@@ -5239,7 +5257,11 @@
 	else
 	{
 		if (e->e_qgrp == NOQGRP || e->e_qdir == NOQDIR)
+		{
+			if (IntSig)
+				return NULL;
 			(void) setnewqueue(e);
+		}
 		if (type ==  DATAFL_LETTER)
 		{
 			qd = e->e_dfqdir;
@@ -5279,6 +5301,8 @@
 			break;
 
 		  default:
+			if (IntSig)
+				return NULL;
 			sm_abort("queuename: bad queue file type %d", type);
 		}
 
--- old/usr/src/cmd/sendmail/src/ratectrl.c	Sat Feb  6 15:36:47 2016
+++ new/usr/src/cmd/sendmail/src/ratectrl.c	Sat Feb  6 15:36:47 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2003 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2003 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -45,7 +45,7 @@
  */
 
 #include <sendmail.h>
-SM_RCSID("@(#)$Id: ratectrl.c,v 8.13 2009/05/05 23:19:34 ca Exp $")
+SM_RCSID("@(#)$Id: ratectrl.c,v 8.14 2013-11-22 20:51:56 ca Exp $")
 
 /*
 **  stuff included - given some warnings (inet_ntoa)
--- old/usr/src/cmd/sendmail/src/readcf.c	Sat Feb  6 15:36:47 2016
+++ new/usr/src/cmd/sendmail/src/readcf.c	Sat Feb  6 15:36:47 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1998-2006, 2008, 2009 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1998-2006, 2008-2010, 2013 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  * Copyright (c) 1983, 1995-1997 Eric P. Allman.  All rights reserved.
  * Copyright (c) 1988, 1993
@@ -14,12 +14,13 @@
 #include <sendmail.h>
 #include <sm/sendmail.h>
 
-SM_RCSID("@(#)$Id: readcf.c,v 8.674 2009/10/26 17:47:00 ca Exp $")
+SM_RCSID("@(#)$Id: readcf.c,v 8.692 2013-11-22 20:51:56 ca Exp $")
 
 #if NETINET || NETINET6
 # include <arpa/inet.h>
 #endif /* NETINET || NETINET6 */
 
+
 #define SECONDS
 #define MINUTES	* 60
 #define HOUR	* 3600
@@ -114,7 +115,15 @@
 	LineNumber = 0;
 
 #if STARTTLS
-	Srv_SSL_Options = Clt_SSL_Options = SSL_OP_ALL;
+	Srv_SSL_Options = SSL_OP_ALL;
+	Clt_SSL_Options = SSL_OP_ALL
+#ifdef SSL_OP_NO_SSLv2
+		| SSL_OP_NO_SSLv2
+#endif
+#ifdef SSL_OP_NO_TICKET
+		| SSL_OP_NO_TICKET
+#endif
+		;
 #endif /* STARTTLS */
 	if (DontLockReadFiles)
 		sff |= SFF_NOLOCK;
@@ -1132,7 +1141,7 @@
 		return;
 	}
 
-	while (sm_io_fgets(f, SM_TIME_DEFAULT, buf, sizeof(buf)) != NULL)
+	while (sm_io_fgets(f, SM_TIME_DEFAULT, buf, sizeof(buf)) >= 0)
 	{
 #if SCANF
 		char wordbuf[MAXLINE + 1];
@@ -2271,6 +2280,18 @@
 # define O_RCPTTHROTDELAY	0xe6
 	{ "BadRcptThrottleDelay",	O_RCPTTHROTDELAY,	OI_SAFE	},
 #endif /* _FFR_RCPTTHROTDELAY */
+#if 0 && _FFR_QOS && defined(SOL_IP) && defined(IP_TOS)
+# define O_INETQOS	0xe7	/* reserved for FFR_QOS */
+	{ "InetQoS",			O_INETQOS,	OI_NONE },
+#endif
+#if STARTTLS && _FFR_FIPSMODE
+# define O_FIPSMODE	0xe8
+	{ "FIPSMode",		O_FIPSMODE,	OI_NONE	},
+#endif /* STARTTLS && _FFR_FIPSMODE  */
+#if _FFR_REJECT_NUL_BYTE
+# define O_REJECTNUL	0xe9
+	{ "RejectNUL",	O_REJECTNUL,	OI_SAFE	},
+#endif /* _FFR_REJECT_NUL_BYTE */
 
 	{ NULL,				'\0',		OI_NONE	}
 };
@@ -2282,71 +2303,109 @@
 	long		sslopt_bits;	/* bits to set/clear */
 } SSL_Option[] =
 {
-/* these are turned on by default */
+/* Workaround for bugs are turned on by default (as well as some others) */
 #ifdef SSL_OP_MICROSOFT_SESS_ID_BUG
 	{ "SSL_OP_MICROSOFT_SESS_ID_BUG",	SSL_OP_MICROSOFT_SESS_ID_BUG	},
-#endif /* SSL_OP_MICROSOFT_SESS_ID_BUG */
+#endif
 #ifdef SSL_OP_NETSCAPE_CHALLENGE_BUG
 	{ "SSL_OP_NETSCAPE_CHALLENGE_BUG",	SSL_OP_NETSCAPE_CHALLENGE_BUG	},
-#endif /* SSL_OP_NETSCAPE_CHALLENGE_BUG */
+#endif
+#ifdef SSL_OP_LEGACY_SERVER_CONNECT
+	{ "SSL_OP_LEGACY_SERVER_CONNECT",	SSL_OP_LEGACY_SERVER_CONNECT	},
+#endif
 #ifdef SSL_OP_NETSCAPE_REUSE_CIPHER_CHANGE_BUG
 	{ "SSL_OP_NETSCAPE_REUSE_CIPHER_CHANGE_BUG",	SSL_OP_NETSCAPE_REUSE_CIPHER_CHANGE_BUG	},
-#endif /* SSL_OP_NETSCAPE_REUSE_CIPHER_CHANGE_BUG */
+#endif
 #ifdef SSL_OP_SSLREF2_REUSE_CERT_TYPE_BUG
 	{ "SSL_OP_SSLREF2_REUSE_CERT_TYPE_BUG",	SSL_OP_SSLREF2_REUSE_CERT_TYPE_BUG	},
-#endif /* SSL_OP_SSLREF2_REUSE_CERT_TYPE_BUG */
+#endif
 #ifdef SSL_OP_MICROSOFT_BIG_SSLV3_BUFFER
 	{ "SSL_OP_MICROSOFT_BIG_SSLV3_BUFFER",	SSL_OP_MICROSOFT_BIG_SSLV3_BUFFER	},
-#endif /* SSL_OP_MICROSOFT_BIG_SSLV3_BUFFER */
+#endif
 #ifdef SSL_OP_MSIE_SSLV2_RSA_PADDING
 	{ "SSL_OP_MSIE_SSLV2_RSA_PADDING",	SSL_OP_MSIE_SSLV2_RSA_PADDING	},
-#endif /* SSL_OP_MSIE_SSLV2_RSA_PADDING */
+#endif
 #ifdef SSL_OP_SSLEAY_080_CLIENT_DH_BUG
 	{ "SSL_OP_SSLEAY_080_CLIENT_DH_BUG",	SSL_OP_SSLEAY_080_CLIENT_DH_BUG	},
-#endif /* SSL_OP_SSLEAY_080_CLIENT_DH_BUG */
+#endif
 #ifdef SSL_OP_TLS_D5_BUG
 	{ "SSL_OP_TLS_D5_BUG",	SSL_OP_TLS_D5_BUG	},
-#endif /* SSL_OP_TLS_D5_BUG */
+#endif
 #ifdef SSL_OP_TLS_BLOCK_PADDING_BUG
 	{ "SSL_OP_TLS_BLOCK_PADDING_BUG",	SSL_OP_TLS_BLOCK_PADDING_BUG	},
-#endif /* SSL_OP_TLS_BLOCK_PADDING_BUG */
+#endif
 #ifdef SSL_OP_DONT_INSERT_EMPTY_FRAGMENTS
 	{ "SSL_OP_DONT_INSERT_EMPTY_FRAGMENTS",	SSL_OP_DONT_INSERT_EMPTY_FRAGMENTS	},
-#endif /* SSL_OP_DONT_INSERT_EMPTY_FRAGMENTS */
+#endif
+#ifdef SSL_OP_ALL
 	{ "SSL_OP_ALL",	SSL_OP_ALL	},
+#endif
+#ifdef SSL_OP_NO_QUERY_MTU
+	{ "SSL_OP_NO_QUERY_MTU",	SSL_OP_NO_QUERY_MTU	},
+#endif
+#ifdef SSL_OP_COOKIE_EXCHANGE
+	{ "SSL_OP_COOKIE_EXCHANGE",	SSL_OP_COOKIE_EXCHANGE	},
+#endif
+#ifdef SSL_OP_NO_TICKET
+	{ "SSL_OP_NO_TICKET",	SSL_OP_NO_TICKET	},
+#endif
+#ifdef SSL_OP_CISCO_ANYCONNECT
+	{ "SSL_OP_CISCO_ANYCONNECT",	SSL_OP_CISCO_ANYCONNECT	},
+#endif
 #ifdef SSL_OP_NO_SESSION_RESUMPTION_ON_RENEGOTIATION
 	{ "SSL_OP_NO_SESSION_RESUMPTION_ON_RENEGOTIATION",	SSL_OP_NO_SESSION_RESUMPTION_ON_RENEGOTIATION	},
-#endif /* SSL_OP_NO_SESSION_RESUMPTION_ON_RENEGOTIATION */
+#endif
+#ifdef SSL_OP_NO_COMPRESSION
+	{ "SSL_OP_NO_COMPRESSION",	SSL_OP_NO_COMPRESSION	},
+#endif
+#ifdef SSL_OP_ALLOW_UNSAFE_LEGACY_RENEGOTIATION
+	{ "SSL_OP_ALLOW_UNSAFE_LEGACY_RENEGOTIATION",	SSL_OP_ALLOW_UNSAFE_LEGACY_RENEGOTIATION	},
+#endif
+#ifdef SSL_OP_SINGLE_ECDH_USE
+	{ "SSL_OP_SINGLE_ECDH_USE",	SSL_OP_SINGLE_ECDH_USE	},
+#endif
+#ifdef SSL_OP_SINGLE_DH_USE
+	{ "SSL_OP_SINGLE_DH_USE",	SSL_OP_SINGLE_DH_USE	},
+#endif
 #ifdef SSL_OP_EPHEMERAL_RSA
 	{ "SSL_OP_EPHEMERAL_RSA",	SSL_OP_EPHEMERAL_RSA	},
-#endif /* SSL_OP_EPHEMERAL_RSA */
+#endif
 #ifdef SSL_OP_CIPHER_SERVER_PREFERENCE
 	{ "SSL_OP_CIPHER_SERVER_PREFERENCE",	SSL_OP_CIPHER_SERVER_PREFERENCE	},
-#endif /* SSL_OP_CIPHER_SERVER_PREFERENCE */
+#endif
 #ifdef SSL_OP_TLS_ROLLBACK_BUG
 	{ "SSL_OP_TLS_ROLLBACK_BUG",	SSL_OP_TLS_ROLLBACK_BUG	},
-#endif /* SSL_OP_TLS_ROLLBACK_BUG */
+#endif
 #ifdef SSL_OP_NO_SSLv2
 	{ "SSL_OP_NO_SSLv2",	SSL_OP_NO_SSLv2	},
-#endif /* SSL_OP_NO_SSLv2 */
+#endif
 #ifdef SSL_OP_NO_SSLv3
 	{ "SSL_OP_NO_SSLv3",	SSL_OP_NO_SSLv3	},
-#endif /* SSL_OP_NO_SSLv3 */
+#endif
 #ifdef SSL_OP_NO_TLSv1
 	{ "SSL_OP_NO_TLSv1",	SSL_OP_NO_TLSv1	},
-#endif /* SSL_OP_NO_TLSv1 */
+#endif
+#ifdef SSL_OP_NO_TLSv1_2
+	{ "SSL_OP_NO_TLSv1_2",	SSL_OP_NO_TLSv1_2	},
+#endif
+#ifdef SSL_OP_NO_TLSv1_1
+	{ "SSL_OP_NO_TLSv1_1",	SSL_OP_NO_TLSv1_1	},
+#endif
 #ifdef SSL_OP_PKCS1_CHECK_1
 	{ "SSL_OP_PKCS1_CHECK_1",	SSL_OP_PKCS1_CHECK_1	},
-#endif /* SSL_OP_PKCS1_CHECK_1 */
+#endif
 #ifdef SSL_OP_PKCS1_CHECK_2
 	{ "SSL_OP_PKCS1_CHECK_2",	SSL_OP_PKCS1_CHECK_2	},
-#endif /* SSL_OP_PKCS1_CHECK_2 */
+#endif
 #ifdef SSL_OP_NETSCAPE_CA_DN_BUG
 	{ "SSL_OP_NETSCAPE_CA_DN_BUG",	SSL_OP_NETSCAPE_CA_DN_BUG	},
-#endif /* SSL_OP_NETSCAPE_CA_DN_BUG */
+#endif
 #ifdef SSL_OP_NETSCAPE_DEMO_CIPHER_CHANGE_BUG
 	{ "SSL_OP_NETSCAPE_DEMO_CIPHER_CHANGE_BUG",	SSL_OP_NETSCAPE_DEMO_CIPHER_CHANGE_BUG	},
-#endif /* SSL_OP_NETSCAPE_DEMO_CIPHER_CHANGE_BUG */
+#endif
+#ifdef SSL_OP_CRYPTOPRO_TLSEXT_BUG
+	{ "SSL_OP_CRYPTOPRO_TLSEXT_BUG",	SSL_OP_CRYPTOPRO_TLSEXT_BUG	},
+#endif
 	{ NULL,		0		}
 };
 #endif /* STARTTLS && _FFR_TLS_1 */
@@ -2639,6 +2698,7 @@
 			set_delivery_mode(*val, e);
 			break;
 
+
 		  default:
 			syserr("Unknown delivery mode %c", *val);
 			finis(false, true, EX_USAGE);
@@ -3446,7 +3506,7 @@
 		ConnectOnlyTo.sa.sa_family = AF_UNSPEC;
 # if NETINET6
 		if (anynet_pton(AF_INET6, val,
-				&ConnectOnlyTo.sin6.sin6_addr) != 1)
+				&ConnectOnlyTo.sin6.sin6_addr) == 1)
 			ConnectOnlyTo.sa.sa_family = AF_INET6;
 		else
 # endif /* NETINET6 */
@@ -3831,6 +3891,11 @@
 		break;
 
 #endif /* STARTTLS */
+#if STARTTLS && _FFR_FIPSMODE
+	  case O_FIPSMODE:
+		FipsMode = atobool(val);
+		break;
+#endif /* STARTTLS && _FFR_FIPSMODE  */
 
 	  case O_CLIENTPORT:
 		setclientoptions(val);
@@ -3985,6 +4050,12 @@
 		break;
 #endif /* _FFR_BADRCPT_SHUTDOWN */
 
+#if _FFR_REJECT_NUL_BYTE
+	  case O_REJECTNUL:
+		RejectNUL = atobool(val);
+		break;
+#endif /* _FFR_REJECT_NUL_BYTE */
+
 	  default:
 		if (tTd(37, 1))
 		{
--- old/usr/src/cmd/sendmail/src/recipient.c	Sat Feb  6 15:36:47 2016
+++ new/usr/src/cmd/sendmail/src/recipient.c	Sat Feb  6 15:36:47 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1998-2003, 2006 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1998-2003, 2006 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  * Copyright (c) 1983, 1995-1997 Eric P. Allman.  All rights reserved.
  * Copyright (c) 1988, 1993
@@ -11,11 +11,9 @@
  *
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sendmail.h>
 
-SM_RCSID("@(#)$Id: recipient.c,v 8.349 2007/07/10 17:01:22 ca Exp $")
+SM_RCSID("@(#)$Id: recipient.c,v 8.351 2013-11-22 20:51:56 ca Exp $")
 
 static void	includetimeout __P((int));
 static ADDRESS	*self_reference __P((ADDRESS *));
@@ -1826,7 +1824,7 @@
 	LineNumber = 0;
 	ctladdr->q_flags &= ~QSELFREF;
 	nincludes = 0;
-	while (sm_io_fgets(fp, SM_TIME_DEFAULT, buf, sizeof(buf)) != NULL &&
+	while (sm_io_fgets(fp, SM_TIME_DEFAULT, buf, sizeof(buf)) >= 0 &&
 	       !maxreached)
 	{
 		fixcrlf(buf, true);
